using System;
using System.Collections.Generic;

namespace AmortizationCalculator
{
    public class AmortizationBluePrint
    {
        public double Principal = 0;
        public double Apr = 0;
        public int PaymentsPerYear;
        public int QtyPayments = 0;
        public DateTime StartDate = DateTime.Now;

        public ExtraPaymentItem[] ExtraPayments = new ExtraPaymentItem[0];

        public AmortizationBluePrint() { }
        public AmortizationBluePrint(AmortizationModel model)
        {
            Principal = model.Principal;
            Apr = model.Apr;
            PaymentsPerYear = (int)model.PaymentsPerYear;
            QtyPayments = model.QtyPayments;
            StartDate = model.StartDate;

            List<ExtraPaymentItem> list = new List<ExtraPaymentItem>();
            foreach (SinglePayment payment in model)
                if (payment.ExtraPayment > 0)
                    list.Add(new ExtraPaymentItem(payment.PaymentNumber - 1, payment.ExtraPayment));
            ExtraPayments = list.ToArray();
        }
    }

    public class ExtraPaymentItem
    {
        public int Index;
        public double Payment;

        public ExtraPaymentItem() { }
        public ExtraPaymentItem(int index, double payment)
        {
            Index = index;
            Payment = payment;
        }
    }
}
